<?php

namespace Drupal\video_toolbox;

/**
 * The video Handler.
 */
class VideoHandler implements VideoHandlerInterface {

  /**
   * Save the video.
   */
  public function saveVideoInfo($description, $video, $user_id, $fid) {
    $database = \Drupal::database()->insert('video_store');
    $database->fields(
      [
        'description' => $description,
        'video_key' => $video,
        'uid' => $user_id,
        'fid' => $fid,
        'upload_date' => time(),
      ]
    )->execute();
  }

  /**
   * Get the video.
   */
  public function getVideoInfo($key) {
    $database = \Drupal::database()->select('video_store', 'vi');
    $database->condition('vi.video_key', $key);
    $results = $database->fields('vi',
      [
        'fid',
        'uid',
        'upload_date',
        'description',
      ]
      );
    $results = $results->execute()->fetchAll(\PDO::FETCH_ASSOC);
    return $results;
  }

  /**
   * Get the videos.
   */
  public function getVideosInfo() {
    $query = \Drupal::database()->select('video_store', 'vs');
    $query->join('file_managed', 'fm', 'fm.fid = vs.fid');
    $query->join('users_field_data', 'ufd', 'ufd.uid = vs.uid');
    $query->addField('ufd', 'name');
    $query->addField('vs', 'description');
    $query->addField('vs', 'video_key');
    $query->addField('fm', 'filemime');
    $query->addField('fm', 'filename');
    $query->addField('vs', 'upload_date');
    $results = $query->execute()->fetchAll(\PDO::FETCH_ASSOC);
    return $results;
  }

  /**
   * Update metadata.
   */
  public function updateVideos($description, $fid) {
    $query = \Drupal::database()->update('video_store');
    $query->condition('fid', [(string) $fid]);
    $query->fields(['description' => (string) $description]);
    $query->execute();

  }

}
